import { CardShape } from "./shapes";
import { CardMove } from "./moves";
declare type CardProps = {
    value: number;
    shape: CardShape;
    move?: CardMove;
    image?: string;
    iNeed?: CardShape;
};
/**
 * Generate a new Card, which may be of any shape and value
 */
export declare class Card {
    value: number;
    shape: CardShape;
    move: CardMove;
    image?: string;
    iNeed?: CardShape;
    constructor(props: CardProps);
    matches: (card: Card) => boolean;
    render: () => string;
    reset: () => void;
    get score(): number;
    static createTriangleCard: (props: Omit<CardProps, "shape">) => Card;
    static createCircleCard: (props: Omit<CardProps, "shape">) => Card;
    static createSquareCard: (props: Omit<CardProps, "shape">) => Card;
    static createStarCard: (props: Omit<CardProps, "shape">) => Card;
    static createCrossCard: (props: Omit<CardProps, "shape">) => Card;
    static createWhotCard: (props: Omit<CardProps, "shape">) => Card;
}
export default Card;
