"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Card = void 0;
var shapes_1 = require("./shapes");
var moves_1 = require("./moves");
/**
 * Generate a new Card, which may be of any shape and value
 */
var Card = /** @class */ (function () {
    function Card(props) {
        var _this = this;
        this.matches = function (card) {
            return (card.shape === _this.shape ||
                card.value === _this.value ||
                (_this.shape === shapes_1.Shapes.Whot && _this.iNeed && _this.iNeed === card.shape) ||
                card.shape === shapes_1.Shapes.Whot);
        };
        this.render = function () { return "".concat(_this.shape, " (").concat(_this.value, ")"); };
        this.reset = function () {
            _this.iNeed = undefined;
        };
        this.value = props.value;
        this.shape = props.shape;
        this.move = props.move || (0, moves_1.GetMove)(props.value);
        this.image = props.image;
        this.iNeed = props.iNeed;
    }
    Object.defineProperty(Card.prototype, "score", {
        get: function () {
            if (this.shape === shapes_1.Shapes.Star)
                return this.value * 2;
            else
                return this.value;
        },
        enumerable: false,
        configurable: true
    });
    Card.createTriangleCard = function (props) {
        return new Card(__assign(__assign({}, props), { shape: shapes_1.Shapes.Triangle }));
    };
    Card.createCircleCard = function (props) {
        return new Card(__assign(__assign({}, props), { shape: shapes_1.Shapes.Circle }));
    };
    Card.createSquareCard = function (props) {
        return new Card(__assign(__assign({}, props), { shape: shapes_1.Shapes.Square }));
    };
    Card.createStarCard = function (props) {
        return new Card(__assign(__assign({}, props), { shape: shapes_1.Shapes.Star }));
    };
    Card.createCrossCard = function (props) {
        return new Card(__assign(__assign({}, props), { shape: shapes_1.Shapes.Cross }));
    };
    Card.createWhotCard = function (props) {
        return new Card(__assign(__assign({}, props), { shape: shapes_1.Shapes.Whot }));
    };
    return Card;
}());
exports.Card = Card;
exports.default = Card;
//# sourceMappingURL=card.js.map